# $Revision: 1.65 $, $Date: 2006/10/01 21:37:53 $
# TODO
# - define _libdir as /lib for all arch?
Summary:	Linux Hotplug Scripts
Summary(pl):	Linuksowe skrypty do urzdze hotplug
Name:		hotplug
Version:	2004_09_23
Release:	8
License:	GPL
Group:		Applications/System
Source0:	ftp://ftp.kernel.org/pub/linux/utils/kernel/hotplug/%{name}-%{version}.tar.bz2
# Source0-md5:	58e6995f9df71ce59b0ec2787019e5fe
Source1:	%{name}.init
Source2:	%{name}-update-usb.usermap
Source3:	%{name}-update-usb.usermap.8
Source4:	%{name}-digicam
Patch0:		%{name}-PLD.patch
Patch1:		%{name}-ifup.patch
Patch2:		%{name}-devlabel.patch
Patch3:		%{name}-sh_shift9.patch
URL:		http://linux-hotplug.sourceforge.net/
BuildRequires:	rpmbuild(macros) >= 1.268
Requires(post,preun):	/sbin/chkconfig
Requires:	/sbin/chkconfig
Requires:	awk
Requires:	bash
Requires:	rc-scripts
Requires:	sed
# Requires wc
Requires:	textutils
Requires:	usbutils
# it is _not_ noarch as it contains %{_libdir}/hotplug directory
#BuildArch:	noarch
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%define		_exec_prefix	/
%define		_libdir			/%{_lib}
%define		_sbindir		/sbin
%define		_gphoto_lib		/usr/%{_lib}/libgphoto2

%description
This package contains the scripts necessary for hotplug Linux support.

%description -l pl
Ten pakiet zawiera skrypty potrzebne do obsugi urzdze hotplug
(podczanych w czasie pracy) pod Linuksem.

%package pci
Summary:	Hotplug pci module
Summary(pl):	Modu pci do hotpluga
Group:		Applications/System
Requires:	%{name} = %{version}-%{release}

%description pci
This is mostly to recover lost boot-time PCI hotplug events. Should
handle 2.4.x and 2.6.x PCI (including Cardbus) hotplugging, with a
consistent framework for adding device and driver specific treatments.

%description pci -l pl
Ten modu suy gwnie do odzyskiwania zdarze hotplug PCI utraconych
w czasie startu systemu. Powinien obsugiwa podczanie urzdze PCI
(wcznie z Cardbus) dla jder 2.4.x i 2.6.x ze spjnym szkieletem do
dodawania urzdze i zachowa specyficznych dla sterownika.

%package input
Summary:	Hotplug input module
Summary(pl):	Modu input do hotpluga
Group:		Applications/System
Requires:	%{name} = %{version}-%{release}

%description input
This loads handlers for those input devices that have drivers compiled
in kernel. Currently stopping is not supported. Should handle 2.6.x
input hotplugging, with a consistent framework for adding device and
driver specific handling.

%description input -l pl
Ten modu wczytuje programy obsugujce te urzdzenia wejciowe, dla
ktrych sterowniki zostay wkompilowane w jdro. Aktualnie wyczanie
nie jest obsugiwane. Powinien obsugiwa podczanie urzdze
wejciowych dla jder 2.6.x ze spjnym szkieletem do dodawania
urzdze i obsug rzeczy specyficznych dla sterownika.

%package isapnp
Summary:	Hotplug isapnp module
Summary(pl):	Modu isapnp do hotpluga
Group:		Applications/System
Requires:	%{name} = %{version}-%{release}

%description isapnp
This module supports PnP ISA cards. Stopping is not supported.

%description isapnp -l pl
Ten modu obsuguje karty PnP ISA. Wyczanie urzdze nie jest
obsugiwane.

%package digicam
Summary:	Hotplug definitions for USB digital cameras
Summary(pl):	Definicje Hotpluga dla aparatw cyfrowych na USB
Group:		Applications/System
Requires(post):	grep
Requires(post,postun):	fileutils
Requires(post,postun):	sed >= 4.0
Requires(postun):	/usr/sbin/groupdel
Requires(pre):	/usr/bin/getgid
Requires(pre):	/usr/sbin/groupadd
Requires:	%{name} = %{version}-%{release}
Requires:	libgphoto2
Requires:	util-linux
Provides:	group(digicam)
Obsoletes:	udev-digicam

%description digicam
This creates appropriate definitions to usb.usermap for digital
cameras based on output of libgphoto2.

%description digicam -l pl
Ten modu dodaje definicje dla aparatw cyfrowych opierajc si na
danych z libgphoto2.

%prep
%setup -q
%patch0 -p1
%patch1 -p1
%patch2 -p1
%patch3 -p1

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT{%{_libdir},%{_sbindir},%{_sysconfdir}/hotplug,/etc/rc.d/init.d,%{_mandir}/man8}

%{__make} install \
	prefix=$RPM_BUILD_ROOT

install etc/hotplug/{dasd.permissions,pnp.distmap,tape.permissions} $RPM_BUILD_ROOT%{_sysconfdir}/hotplug/

install %{SOURCE2} $RPM_BUILD_ROOT%{_sbindir}
install %{SOURCE3} $RPM_BUILD_ROOT%{_mandir}/man8
install %{SOURCE1} $RPM_BUILD_ROOT/etc/rc.d/init.d/hotplug
ln -s %{_sysconfdir}/hotplug.d $RPM_BUILD_ROOT%{_libdir}/%{name}
install %{SOURCE4} $RPM_BUILD_ROOT%{_sysconfdir}/hotplug/usb/digicam

%clean
rm -rf $RPM_BUILD_ROOT

# NOTE: don't restart hotplug on upgrade (not needed and does evil things
# like reconfiguring hotplug-driven devices, disabling network connections
# etc.)

%post
/sbin/chkconfig --add hotplug

%preun
if [ "$1" = "0" ] ; then
	%service hotplug stop
	/sbin/chkconfig --del hotplug
fi

%pre digicam
%groupadd -P %{name}-digicam -g 135 digicam

%post digicam
if [ "$1" = "1" ]; then
	usermap="%{_sysconfdir}/hotplug/usb.usermap"
	if [ -f "$usermap" ]; then
		%{__sed} -i -e '/digicam/d' $usermap
		%{_gphoto_lib}/print-usb-usermap digicam | grep -v '#' >> "$usermap"
	else
		umask 022
		%{_gphoto_lib}/print-usb-usermap digicam | grep -v '#' > "$usermap"
	fi
fi

%postun digicam
if [ "$1" = "0" ]; then
	usermap="%{_sysconfdir}/hotplug/usb.usermap"
	if [ -f "$usermap" ]; then
		%{__sed} -i -e '/digicam/d' "$usermap"
	fi
	%groupremove digicam
fi

%files
%defattr(644,root,root,755)
%doc README ChangeLog
%attr(755,root,root) %{_sbindir}/*
%attr(754,root,root) /etc/rc.d/init.d/*
%dir %{_sysconfdir}/hotplug
%exclude %{_sysconfdir}/hotplug/pci.*
%exclude %{_sysconfdir}/hotplug/input.*
%exclude %{_sysconfdir}/hotplug/pnp.*
%{_sysconfdir}/hotplug/hotplug.functions
%attr(755,root,root) %{_sysconfdir}/hotplug/*.agent
%attr(755,root,root) %{_sysconfdir}/hotplug/*.rc
%dir %{_sysconfdir}/hotplug/usb
%exclude %{_sysconfdir}/hotplug/usb/digicam
%config(noreplace) %verify(not md5 mtime size) %{_sysconfdir}/hotplug/blacklist
%config(noreplace) %verify(not md5 mtime size) %{_sysconfdir}/hotplug/*map
%config(noreplace) %verify(not md5 mtime size) %{_sysconfdir}/hotplug/*.permissions
%dir %{_sysconfdir}/hotplug.d
%dir %{_sysconfdir}/hotplug.d/default
%attr(755,root,root) %{_sysconfdir}/hotplug.d/default/*.hotplug
%{_libdir}/hotplug
%{_mandir}/man8/*.8*
%dir /var/run/usb
%dir /var/log/hotplug

%files pci
%defattr(644,root,root,755)
%dir %{_sysconfdir}/hotplug/pci
%attr(755,root,root) %{_sysconfdir}/hotplug/pci.*

%files input
%defattr(644,root,root,755)
%attr(755,root,root) %{_sysconfdir}/hotplug/input.*

%files isapnp
%defattr(644,root,root,755)
%{_sysconfdir}/hotplug/pnp.*
%attr(755,root,root) %{_sysconfdir}/hotplug/pnp.rc

%files digicam
%defattr(644,root,root,755)
%attr(755,root,root) %{_sysconfdir}/hotplug/usb/digicam

%define date	%(echo `LC_ALL="C" date +"%a %b %d %Y"`)
%changelog
* %{date} PLD Team <feedback@pld-linux.org>
All persons listed below can be reached at <cvs_login>@pld-linux.org

$Log: hotplug.spec,v $
Revision 1.65  2006/10/01 21:37:53  glen
- rel 8

Revision 1.64  2006/09/08 18:04:07  glen
- rel 7 (rebuild with fixed %useradd/%groupadd macros)

Revision 1.63  2006/04/15 12:59:02  glen
- rel 6

Revision 1.62  2006/02/28 17:56:06  glen
- fix gphoto dir for lib64, rel 5

Revision 1.61  2006/02/27 23:41:22  glen
- 64 bit arch broken for -digicam

Revision 1.60  2006/02/27 23:38:50  glen
- use %service

Revision 1.59  2005/10/19 16:02:37  freetz
- O: udev-digicam

Revision 1.58  2005/10/13 09:08:34  glen
- full chkconfig require, adapterized; rel 4

Revision 1.57  2005/09/13 15:47:04  patrys
- bump!
- in current FTP version isapnp is builtin and behaves bad on some PCI cards (see bugtracker)
- STBR

Revision 1.56  2005/06/20 16:05:25  romke
- split isapnp rc script to separate hotplug-isapnp package,
- release 3, works for me, STBR

Revision 1.55  2005/05/19 10:16:33  pzurowski
- added patch, which eleminates "shift 9" in scripts... it doesn't work properly with "shift 9"

Revision 1.54  2005/05/01 17:31:30  glen
- use %useradd/%groupadd macros

Revision 1.53  2005/01/15 18:45:40  zergin
- digicam script modification
- digicam: R:util-linux
- rel++ from 1 to 2
- STBR

Revision 1.52  2004/10/23 14:08:45  ankry
- %groupremove support

Revision 1.51  2004/10/23 13:53:54  qboosh
- documented why no hotplug restart, pre digicam fixes/unifications

Revision 1.50  2004/09/24 22:39:33  arekm
- add few missing files

Revision 1.49  2004/09/24 22:33:40  arekm
- updated to 20040924 (Mateusz Murawski)

Revision 1.48  2004/09/23 23:43:59  arekm
- update to 2004_09_20

Revision 1.47  2004/09/18 17:23:57  grzegol
- simplified installation
- added /var/run/usb and /var/log/hotplug dirs
- rel. 7

Revision 1.46  2004/09/18 13:43:40  ggodlewski
- added devlabel support

Revision 1.45  2004/08/12 09:58:34  arekm
- rel 5 (it was broken, hotplug.functions was missing)

Revision 1.44  2004/08/11 05:30:38  ankry
- not noarch, rel. 4

Revision 1.43  2004/08/08 17:19:40  roman
- removed stupid patch
- release --

Revision 1.42  2004/08/07 21:46:39  roman
- added a patch adapting hotplug to PLD readlink
- won't build yet, 'cause hotplug-digicam is missing from the CVS; when
  found, please rebuild to make package usable
- release++

Revision 1.41  2004/08/06 18:06:05  qboosh
- spelling, security/upgrade/umask/deps fixes for scripts in -digicam

Revision 1.40  2004/08/06 14:53:08  zergin
- forgot about removing digicams definitions when uninstalling..

Revision 1.39  2004/08/06 13:53:14  zergin
- added support for usb digital cameras (hotplug-digicam)
  based on idea by: Michal Kochanowicz <michal.at.michal.waw.pl>
- hotplug-digicam: new group digicam

Revision 1.38  2004/05/08 13:07:57  qboosh
- pl for -pci and -input

Revision 1.37  2004/05/08 11:10:33  arekm
- missing defattr

Revision 1.36  2004/04/29 17:23:28  havner
- forgot about release

Revision 1.35  2004/04/29 16:00:15  havner
- cosmetics

Revision 1.34  2004/04/29 15:57:49  havner
- split hotplug to hotplug, hotplug-pci and hotplug-input packages.
  pci functionality in this version is sometimes annoying, eg. oss and
  alsa drivers, so let's give a choice if someone does not want it.

Revision 1.33  2004/04/02 00:12:16  arekm
- updated but still problematic

Revision 1.32  2004/03/31 00:49:48  arekm
- do not use it, yet

Revision 1.31  2004/03/12 00:46:08  arekm
- updated to 2004_03_11

Revision 1.30  2004/01/05 19:06:42  arekm
- updated to 2004_01_05 (better handling of 2.6 kernels)

Revision 1.29  2003/10/12 12:04:09  blues
- cosmetics

Revision 1.28  2003/10/11 10:34:23  wiget
- add 'hotplug' as second argument to ifup invocation

Revision 1.27  2003/08/22 15:18:48  ankry
- attributes fix

Revision 1.26  2003/08/17 12:31:37  arekm
- updated to 2003_08_05

Revision 1.25  2003/07/29 15:45:00  qboosh
- more specific Requires, more changes where needed

Revision 1.24  2003/07/13 12:08:11  grzegol
- updated PLD patch (now pci.rc returns proper value)
- rel. 5

Revision 1.23  2003/07/10 20:38:53  arekm
- added missing directories; make it usable

Revision 1.22  2003/07/07 12:44:04  arekm
- include _libdir/hotplug

Revision 1.21  2003/07/07 12:09:21  arekm
- include debians update-usb.usermap; rel 2

Revision 1.20  2003/06/25 20:44:06  wiget
- updated to 2003_05_01

Revision 1.19  2003/06/22 10:59:30  eothane
- http://belnet.sourceforge->http://dl.sourceforge

Revision 1.18  2003/05/27 08:59:02  trojan
- added Source-md5

Revision 1.17  2003/05/25 05:48:42  misi3k
- massive attack s/pld.org.pl/pld-linux.org/

Revision 1.16  2002/11/25 14:58:56  marcus
- use new %doc

Revision 1.15  2002/08/30 16:40:12  misiek
- updated to 2002_08_26

Revision 1.14  2002/05/30 11:44:26  mkochano
- Release 3.
- Requires usbutils, sed and bash.
- Renames sh-and-PLD patch to PLD patch.

Revision 1.13  2002/05/28 22:50:33  mkochano
- Release 2 (but still not finished).
- More requires.
- Added sh_and_PLD patch.

Revision 1.12  2002/05/21 10:51:08  wojtekka
- upgrade to 2002_04_01,
- PLDized init.d script.

Revision 1.11  2002/04/29 19:28:52  wojtekka
- added missing +x, release 3.

Revision 1.10  2002/04/25 16:34:06  arturs
- fixed a small typo

Revision 1.9  2002/03/26 10:39:04  qboosh
- better pl translation
- check lock before calling hotplug stop

Revision 1.8  2002/02/23 02:30:45  kloczek
- adapterized.

Revision 1.7  2002/02/22 23:29:03  kloczek
- removed all Group fields translations (our rpm now can handle translating
  Group field using gettext).

Revision 1.6  2002/01/18 02:13:17  kloczek
- perl -pi -e "s/pld-list\@pld.org.pl/feedback\@pld.org.pl/"

Revision 1.5  2001/11/04 02:18:21  blues
- pl tanslation added + some cosmetics
  NOTE: there is new version avaible

Revision 1.4  2001/07/26 05:42:08  saq
- reverting last change: removing new macros from %p{re,ost}{,un}

Revision 1.2  2001/04/25 11:04:29  wiget
- rewrite in PLD style
